﻿// =====================================================================
//                               actDate.js
// © 2013  Dunin Technologie Inc.
// =====================================================================

// - DÉFINITION --------------------------------------------------------
// Acteur DATE
// --------------------------------------------------------------------

// - NOTES -------------------------------------------------------------
// ---------------------------------------------------------------------

// - HISTORIQUE --------------------------------------------------------
// 2013-06-03  Pierre-Do                  Création
// ---------------------------------------------------------------------


// ---------------------------------------------------------------------
// Construit l'acteur Date
ConstV7.prototype.ConstActeurDate = function (elem, acteurParam, objCourant) {
    var that = this;
    var $elem = $(elem);

    //Traitement du <Label>
    var $lbl = $elem.find('label');
    if ($lbl.length) {
        $lbl.text(acteurParam['prop']);                  // Nom de la propriété
    }


    //Traitement du <input>
    var $txt = $elem.find('input');     // trouve la balise Input dans la source
    if ($txt.length) {
        $txt.attr('id', that.NouveauID(objCourant.Id + "~" + acteurParam['prop']));  // Ajoute ID
        $txt.data("objet", objCourant);                                             // Stock un pointeur sur l'objet courant
        $txt.data("acteur", "DATE");
    }


    //Min
    var min;
    if (acteurParam['min'] != undefined) {
        min = kendo.parseDate(acteurParam['min'], "yyyy-MM-dd");
    }

    //Max
    var max;
    if (acteurParam['max'] != undefined) {
        max = kendo.parseDate(acteurParam['max'], "yyyy-MM-dd");
    }

    //culture
    var culture;
    if (acteurParam['culture'] != undefined) {
        culture = acteurParam['culture'];
    }

    //format
    var format;
    if (acteurParam['format'] != undefined) {
        format = acteurParam['format'];
    }


    $txt.kendoDatePicker({
        value: objCourant[acteurParam['prop']],
        min: min,
        max: max,
        culture: culture,
        format: format,
        change: function (e) {
            that.udpDateOnChange(e, acteurParam['prop']);
        }
    });
}


ConstV7.prototype.udpDateOnChange = function (e, prop) {

    var elemKendo = e.sender;                           //l'objet Kendo DropDownList
    var elem = e.sender.element;                        //l'objet <Input>
    var obj = elem.data("objet");                       //l'objet V7

    obj[prop] = elemKendo.value();
}