﻿// =====================================================================
//                               actSelTheme.js
// © 2013  Dunin Technologie Inc.
// =====================================================================

// - DÉFINITION --------------------------------------------------------
// Acteur SELTHEME
// --------------------------------------------------------------------

// - NOTES -------------------------------------------------------------
// ---------------------------------------------------------------------

// - HISTORIQUE --------------------------------------------------------
// 2013-05-24  Pierre-Do                  Création
// ---------------------------------------------------------------------

// ---------------------------------------------------------------------
// Construit un acteur qui permet de faire la selection d'un theme d'affichage
ConstV7.prototype.ConstActeurSelTheme = function (elem, acteurParam) {
    var that = this;
    var $elem = $(elem);

    var theme = new Array("Silver", "Black", "High Contrast");   //Liste des themes disponible


    $elem.kendoDropDownList({
        dataSource: theme,
        index: 0,
        select: function(e) {
            that.ChangeTheme(this.dataItem(e.item.index()));
        }
    });
}

// ---------------------------------------------------------------------
// Change le theme d'une page
ConstV7.prototype.ChangeTheme = function (theme) {
    // Pour réglé les path relatif différents en fonction de la page Moteur.html ou Constructeur.html
    var nomPage;        //Contien le nom de la page html actuellement chargé
    var path;           //Contien le path d'accès en fonction de la page


    nomPage = unescape(location.href);
    nomPage = nomPage.substr(nomPage.lastIndexOf('/') + 1)


    switch (nomPage) {
        case "Constructeur.html":
            path = "Styles/Themes/";
            break;
        case "Moteur.html":
            path = "Constructeur/Styles/Themes/";
            break;
    }

    $('head').find('link[rel=stylesheet][href*="kendo"]').remove();     //Retire les liens des CSS Kendo

    switch (theme) {
        case 'Silver':
            $('head').prepend('<link href="' + path + 'kendo.silver.min.css" rel="stylesheet" />');
            break;
        case 'Black':
            $('head').prepend('<link href="' + path + 'kendo.black.min.css" rel="stylesheet" />');
            break;
        case 'High Contrast':
            $('head').prepend('<link href="' + path + 'kendo.highcontrast.min.css" rel="stylesheet" />');
            break;
    }

    $('head').prepend('<link href="' + path + 'kendo.common.min.css" rel="stylesheet" />');
}