﻿// =====================================================================
//                               actTextNum.js
// © 2013  Dunin Technologie Inc.
// =====================================================================

// - DÉFINITION --------------------------------------------------------
// Acteur TEXT Numérique
// --------------------------------------------------------------------

// - NOTES -------------------------------------------------------------
// ---------------------------------------------------------------------

// - HISTORIQUE --------------------------------------------------------
// 2013-05-21  Pierre-Do                  Création
// ---------------------------------------------------------------------

// ---------------------------------------------------------------------
// Construit l'acteur TEXTNumérique

ConstV7.prototype.ConstActeurTextNum = function (elem, acteurParam, objCourant) {
    var that = this;
    var $elem = $(elem);

    //Traitement du <Label>
    var $lbl = $elem.find('label');
    if ($lbl.length) {
        $lbl.text(acteurParam['prop']);                  // Nom de la propriété
    }


    //Traitement du <input>
    var $txt = $elem.find('input[type=number]');     // trouve la balise Input dans la source
    if ($txt.length) {
        $txt.attr('id', that.NouveauID(objCourant.Id + "~" + acteurParam['prop']));  // Ajoute ID
        $txt.val(objCourant[acteurParam['prop']]);                                   // Valeur de l'attibue
        $txt.data("objet", objCourant);                                             // Stock un pointeur sur l'objet courant
        $txt.data("acteur", "TEXTNUM");

        //Ajoute une evenment sur le spin si demandé
        var spinEvent;
        if (acteurParam['onSpinEvent'] != undefined && acteurParam['onSpinEvent'] == 'true') {
            spinEvent = function () {
                that.udpTextNumOnSpin(this, acteurParam['prop']);
            }
        }

        //Min
        var min;
        if (acteurParam['min'] != undefined) {
            min = parseInt(acteurParam['min']);
        }

        //Max
        var max;
        if (acteurParam['max'] != undefined) {
            max = parseInt(acteurParam['max']);
        }

        //step
        var step;
        if (acteurParam['step'] != undefined) {
            step = parseInt(acteurParam['step']);
        }

        //culture
        var culture;
        if (acteurParam['culture'] != undefined) {
            culture = acteurParam['culture'];
        }

        //format
        var format;
        if (acteurParam['format'] != undefined) {
            format = acteurParam['format'];
        }

        //Decimale
        var decimale;
        if (acteurParam['decimale'] != undefined) {
            decimale = parseInt(acteurParam['decimale']);
        }

        //PlaceHolder
        var placeholder;
        if (acteurParam['info'] != undefined) {
            placeholder = acteurParam['info'];
        }

        //Spinner
        var spinner = true;
        if (acteurParam['spinner'] != undefined && acteurParam['spinner'] == 'false') {
            spinner = false;
        }


        //Transforme en Kendo Numerique
        $txt.kendoNumericTextBox({
            format: "0",
            change: function () {
                that.udpTextNumOnChange(this, acteurParam['prop']);
            },
            spin: spinEvent,
            min: min,
            max: max,
            step: step,
            culture: culture,
            format: format,
            decimal: decimale,
            placeholder: placeholder,
            spinners: spinner
        });


    }
}

ConstV7.prototype.udpTextNumOnChange = function (elem, prop) {

    $elem = $(elem["element"]);   // Atteind l'élément Kendo
    objV7 = $elem.data("objet");
    objV7[prop] = $elem.val();
}


ConstV7.prototype.udpTextNumOnSpin = function (elem, prop) {

    $elem = $(elem["element"]);   // Atteind l'élément Kendo
    objV7 = $elem.data("objet");
    objV7[prop] = $elem.val();
}