﻿// =====================================================================
//                               Const.js
// © 2013  Dunin Technologie Inc.
// =====================================================================

// - DÉFINITION --------------------------------------------------------
// Fonctions de ContV7 spécifiques à la création de l'interface
// --------------------------------------------------------------------

// - NOTES -------------------------------------------------------------
// ---------------------------------------------------------------------

// - HISTORIQUE --------------------------------------------------------
// 2013-05-21  Pierre-Do                  Création
// ---------------------------------------------------------------------

// ---------------------------------------------------------------------
// Construit à partir d'une vue memoire passé en paramêtre
ConstV7.prototype.Construit = function (vue, objCourant, culture) {
    this.vueHtml = vue;

    //Ajuste la culture
    if (culture != undefined) {
        kendo.culture(culture);
    }
    else {
        kendo.culture("fr-CA");
    }

    $('link[rel=stylesheet]').remove();                 //Vide les CSS du HEAD de la page "coquille" index.html
    $('body').empty();;                                 //Efface tout le contenu de la page destination sou BODY
    $('body').append('<div id="container"></div>');     //Ajoute sous BODY une balise DIV qui servira de conteneur à la nouvelle vue
    //$('#container').hide();                             //Cache cette section pour ne pas que l'utilisateur voir la page se creer au fur et à mesure
    
    this.VueHtmlCharge(vue, objCourant);
}

// ---------------------------------------------------------------------
// Construit a partir de Path. Charge la vue du serveur web
ConstV7.prototype.ConstruitFromWeb = function (vue, objCourant, culture) {
    var that = this;
    this.vueHtml = vue;

    //Ajuste la culture
    if (culture != undefined) {
        kendo.culture(culture);
    }
    else {
        kendo.culture("fr-CA");
    }

    $('link[rel=stylesheet]').remove();                 //Vide les CSS du HEAD de la page "coquille" index.html
    $('body').empty();;                                 //Efface tout le contenu de la page destination sou BODY
    $('body').append('<div id="container"></div>');     //Ajoute sous BODY une balise DIV qui servira de conteneur à la nouvelle vue
    //$('#container').hide();                             //Cache cette section pour ne pas que l'utilisateur voir la page se creer au fur et à mesure


    //Charge la vue du serveur (remplacer éventuellement par un HTML en memoire passé durectement du moteur)
    $.ajax({
        url: vue,
        data: {},
        success: function (vueHtml) {
            that.VueHtmlCharge(vueHtml, objCourant);
        },
        error: function (request, status, error) {
            alert(request.statusText);
        },
        dataType: 'html'
    });
}

// ---------------------------------------------------------------------
// Recoit la vue téléchargée du serveur

ConstV7.prototype.VueHtmlCharge = function (vueHtml, objCourant) {
    //Detecte la présence de la balise HEAD. Si présente = Vue avec des informations CSS. Sinon= Sous vue sans balise HEAD ou BODY.
    if (vueHtml.indexOf("<head>")) {
        //Ajoute le contenu du HEAD dans la coquille
        //NOTE: il faudrait être plus sélectif avec l'importaion de balise pour évité les problèmes de balise invalide.

        var contenuHead = vueHtml.substring(vueHtml.indexOf("<head>") + 6, vueHtml.indexOf("</head>"));
        var contenuBody = vueHtml.substring(vueHtml.indexOf("<body>") + 6, vueHtml.indexOf("</body>"));

        var $head = $('<div></div>');   //Crée un objet DOM de type jQuery. Le $ devant le nom de variable indique au programmeur que l'objet possède des fonction de jQuery
        $head.html(contenuHead);        //Encapsule le contenue du Head de la vue chargé dans notre nouvelle balise <div>

        //Copie le titre si passé dans le vue
        if (contenuHead.indexOf("<title>")) {
            document.title = contenuHead.substring(contenuHead.indexOf('<title>') + 7, contenuHead.indexOf('</title>'));
        }

        //Copie les CSS fourni par la vue
        $('head').append($('link[rel="stylesheet"]', $head));


        //Copie le contenu de la vue dans le DOM Actif
        $('#container').append(contenuBody);


        this.ParseVue(objCourant);     //Parcour la vue 
    }
    else {
        //this.ParseVue(vueHtml, $('#container'));
    }
}

// ---------------------------------------------------------------------
// Parcoure les balises de la vue

ConstV7.prototype.ParseVue = function (objCourant) {
    var that = this;
    $('body').children().each(function () {
        that.AnalyseElement(this, objCourant);    //Passe l'objet courrant 
    });

    $('#container').show();                     //Vue construite, affiche le résultat d'un coup.
}

// ---------------------------------------------------------------------
// Analyse chaque élément de la vue. Si balise data- détecté, un traitement sera fait. Sinon on copie l'élément sous l'élément de destimation (DOM actif)

ConstV7.prototype.AnalyseElement = function (elem, objCourant) {
    var that = this;
    var objCour = objCourant;                   //Garde une copie local de l'objet courrant
    var enfantTraite = false;                   //Indique si les enfants on été traité dans ContruitActeur
    var $elem = $(elem);                        //Converti en objet jQuery


    // Recherche des tag data-
    var att = elem.attributes, attributes = [];
    for (var i = 0 ; i < att.length; i++) {
        switch (att[i].name) {
            case "data-ref":
                objCour = objCourant[att[i].value];
                break;
            case "data-acteur":
                enfantTraite = that.ConstruitActeur(elem, objCour);
                break;
            case "data-SousVue":
                //that.AjouteSousVue(elem, $destElem);
                break;
        }
    }

    // Recherche des style Kendo de base à appliqué au besion
    switch ($elem.get(0).tagName.toLowerCase()) {
        case "section":
            $elem.addClass("k-content");
            break;
    }

    if (enfantTraite === false) {
        $(elem).children().each(function () {
            that.AnalyseElement(this, objCour);         //Fonction recursive qui refaire le même travail pour chaques enfants
        });
    }

}


// ---------------------------------------------------------------------
// Construit l'acteur correspondant à l'élément

ConstV7.prototype.ConstruitActeur = function (elem, objCourant) {
    var that = this;
    var acteurParam = new Object;
    var $elem = $(elem);
    var enfantTraite = false;

    //Extact les param de l'Acteur
    if ($elem.attr('data-acteurparam') !== undefined) {
        var params = $elem.attr('data-acteurparam').split(';');
        for (var i = 0; i < params.length; i++) {
            var KeyVal = params[i].split('=');
            acteurParam[KeyVal[0]] = KeyVal[1];
        }
    }

    switch ($elem.attr('data-acteur')) {
        case 'SELTHEME':
            var i = 1;
            that.ConstActeurSelTheme(elem, acteurParam);
            break;
        case 'TEXT':
            that.ConstActeurText(elem, acteurParam, objCourant);
            enfantTraite = true;
            break;
        case 'TEXTNUM':
            that.ConstActeurTextNum(elem, acteurParam, objCourant);
            enfantTraite = true;
            break;
        case 'TEXTLBL':
            that.ConstActeurTextLbl(elem, acteurParam, objCourant);
            enfantTraite = true;
            break;
        case 'LISTE':
            that.ConstActeurListe(elem, acteurParam, objCourant);
            enfantTraite = true;
            break;
        case 'DATE':
            that.ConstActeurDate(elem, acteurParam, objCourant);
            enfantTraite = true;
            break;
        case 'ONGLETS':
            that.ConstActeurOnglets(elem, acteurParam, objCourant);
            enfantTraite = false;
            break;
    }

    return enfantTraite;
}

ConstV7.prototype.NouveauID = function (ObjIdProp) {
    
    var nbrObj = $("[id*='" + ObjIdProp + "']").length;

    return ObjIdProp + "~" + (nbrObj + 1);
}
