﻿// =====================================================================
//                               upd.js
// © 2013  Dunin Technologie Inc.
// =====================================================================

// - DÉFINITION --------------------------------------------------------
// fonctions de constV7 spécifiques aux MAJ
// --------------------------------------------------------------------

// - NOTES -------------------------------------------------------------
// ---------------------------------------------------------------------

// - HISTORIQUE --------------------------------------------------------
// 2013-05-21  Pierre-Do                  Création
// ---------------------------------------------------------------------

// ---------------------------------------------------------------------
// Met a jour la valeur d'un élément du DOM. Appeler par le moteur.
ConstV7.prototype.UpdateValeur = function (objIdProp) {

    var listeElem = $('[id*="' + objIdProp + '"]')          //Recherche les élément du DOM contenant l'ID unique ~ Propriété

    for (var i = 0; i <= (listeElem.length - 1) ; i++) {     
        var $elem = $(listeElem[i]);                //Element jquery du DOM 
        var propNom = objIdProp.split('~')[1];      //Nom de la propriété
        var objV7 = $elem.data("objet");            //Objet V7

        switch ($elem.data("acteur")) {
            case 'TEXT':
                $elem.val(objV7[propNom]);
                break;
            case 'TEXTNUM':
                var numTxt = $elem.data("kendoNumericTextBox");
                numTxt.value(objV7[propNom]);
                break;
            case 'TEXTLBL':
                $elem.text(objV7[propNom]);
                break;
            case 'DATE':
                var datePick = $elem.data("kendoDatePicker");
                datePick.value(objV7[propNom]);
                break;
            case 'LISTE':
                var dropDown = $elem.data("kendoDropDownList");
                dropDown.value(objV7[propNom]);
                break;
        }
    }    
}

// ---------------------------------------------------------------------
// Met a jour la caracteristique 'modifiable' d'un élément du DOM. Appeler par le moteur.
ConstV7.prototype.UpdateCModifiable = function (objIdProp) {

    var listeElem = $('[id*="' + objIdProp + '"]')          //Recherche les élément du DOM contenant l'ID unique ~ Propriété

    for (var i = 0; i <= (listeElem.length - 1) ; i++) {

        // ICI ON DOIT ALLER CHERCHER LA VALEUR DE LA CARACTERISTIQUE DE L'OBJECT V7 MODIFIABLE
        // Pour l'instant de fait comme si la valeur Modifiable passait à False
        var $elem = $(listeElem[i]);                //Element jquery du DOM 
        var propNom = objIdProp.split('~')[1];      //Nom de la propriété
        var objV7 = $elem.data("objet");            //Objet V7

        switch ($elem.data("acteur")) {
            case 'TEXT':
                $elem.prop("readonly",true);
                break;
            case 'TEXTNUM':
                var numTxt = $elem.data("kendoNumericTextBox");
                numTxt.readonly();
                break;
            case 'DATE':
                var datePick = $elem.data("kendoDatePicker");
                datePick.readonly();
                break;
            case 'LISTE':
                var dropDown = $elem.data("kendoDropDownList");
                dropDown.readonly();
                break;
        }
    }
}

// ---------------------------------------------------------------------
// Met a jour la caracteristique 'Valeur possible' d'un élément LISTE, LISTEMOD du DOM. Appeler par le moteur.
ConstV7.prototype.UpdateCValPoss = function (objIdProp) {

    var listeElem = $('[id*="' + objIdProp + '"]')          //Recherche les élément du DOM contenant l'ID unique ~ Propriété

    for (var i = 0; i <= (listeElem.length - 1) ; i++) {

        // ICI ON DOIT ALLER CHERCHER LA NOUVELLE LISTE POSSIBLE DE LA CARACTERISTIQUE DE L'OBJECT V7 
        // Simule cela avec cette collection
        var listeChoix = [
            { texte: "Modif1", valeur: "1" },
            { texte: "Modif2", valeur: "2" },
            { texte: "Modif3", valeur: "3" },
            { texte: "Modif4", valeur: "4" },
            { texte: "Modif5", valeur: "5" }
        ];

        var $elem = $(listeElem[i]);                //Element jquery du DOM 
        var propNom = objIdProp.split('~')[1];      //Nom de la propriété
        var objV7 = $elem.data("objet");            //Objet V7

        switch ($elem.data("acteur")) {
            case 'LISTE':
                var cbo = $elem.data("kendoDropDownList");
                cbo.setDataSource(new kendo.data.DataSource({ data: listeChoix }));
                break;
        }
    }
}